package org.jboss.wfink.ejb30;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.PostActivate;
import javax.ejb.PrePassivate;
import javax.ejb.Remove;
import javax.ejb.Stateful;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.logging.Logger;
import org.jboss.wfink.ejb30.jpa.KeyValue;

@Stateful
public class SFTestBean implements SFTest {
  private static final Logger LOG = Logger.getLogger(SFTestBean.class);
  
  @PersistenceContext
  EntityManager em;

  private String key;
  
  @PostConstruct
  private void postConstruct() {
    LOG.fatal("CONSTRUCT");
  }
  @PreDestroy
  private void preDestroy() {
    LOG.fatal("DESTROY");
  }
  @PrePassivate
  private void prePassivate() {
    LOG.fatal("PASSIVATE");
  }
  
  @PostActivate
  private void postActivate() {
    LOG.fatal("ACTIVATE");
  }
  @Override
  public void createKeyValue(String key, String value) {
    this.key = key;
    KeyValue entity = new KeyValue(key, value);
    em.persist(entity);
  }
  
  @Override
  public String getValue() {
    KeyValue entity = em.find(KeyValue.class, key);
    return entity.getValue();
  }
  
  @Override
  @Remove
  public void remove() {
    KeyValue entity = em.find(KeyValue.class, key);
    em.remove(entity);
  }
}
