package org.jboss.wfink.ejb30;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.logging.Logger;
import org.jboss.wfink.ejb30.jpa.KeyValue;

@Stateless
public class SLTestBean implements SLTest {
  private static final Logger LOG = Logger.getLogger(SLTestBean.class);
  
  @PersistenceContext
  EntityManager em;

  @PostConstruct
  private void postConstruct() {
    LOG.fatal("CONSTRUCT");
  }
  @PreDestroy
  private void preDestroy() {
    LOG.fatal("DESTROY");
  }
  @Override
  public void createKeyValue(String key, String value) {
    KeyValue entity = new KeyValue(key, value);
    em.persist(entity);
  }
  
  @Override
  public String getValue(String key) {
    KeyValue entity = em.find(KeyValue.class, key);
    return entity.getValue();
  }
  
  @Override
  public void remove(String key) {
    KeyValue entity = em.find(KeyValue.class, key);
    em.remove(entity);
  }
}
