package org.jboss.wfink.ejb30;

import java.util.Date;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;

public class StatelessMain {
  private final static String SLSB_NAME = "ejb:/ejb30-jpa//SLTestBean!" + SLTest.class.getName();
  private static InitialContext context;
  
  static {
    Properties p = new Properties();
    p.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
    p.put("remote.connections", "default");
    p.put("remote.connection.default.port", "8080");
    p.put("remote.connection.default.host", "localhost");
//    p.put("remote.connection.default.username", "quickuser");
//    p.put("remote.connection.default.password", "quick-123");

    EJBClientConfiguration cc = new PropertiesBasedEJBClientConfiguration(p);
    ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(cc);
    EJBClientContext.setSelector(selector);

    Properties props = new Properties();
    props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
    try {
      context = new InitialContext(props);
    } catch (NamingException e) {
      e.printStackTrace();
      System.exit(255);
    }
  }


  public static void main(String[] args) throws NamingException, InterruptedException {
    SLTest slsb = (SLTest) context.lookup(SLSB_NAME);
    String date = new Date().toString();
    String value = "a test at " + date;
    slsb.createKeyValue(date, value);
    String readValue = slsb.getValue(date);
    
    if(!value.equals(readValue)) {
      throw new RuntimeException("Created and read value differ");
    }
    slsb.remove(date);
  }

}
